#include <pthread.h>

#include "netex.h"
#include "nx_curses.h"

bool running;
pthread_t ui_thread;
void* ui_routine(void* args);


unsigned long start_ui(void)
{
    const int thread_result = pthread_create(&ui_thread, NULL, ui_routine, NULL);
    return thread_result;
}

void* ui_routine(void* args)
{
    (void)args;
    initscr();
    noecho(); // Stop printing key presses
    if (has_colors() && can_change_color())
    {
        start_color();
        PRINT_LINE("%i colors available, %i color pairs available.", COLORS, COLOR_PAIRS);

        init_pair(DEF_COLOR_PAIR, COLOR_WHITE, COLOR_BLACK);
        init_pair(DEF_WIN_COLOR, COLOR_GREEN, COLOR_BLACK);
    }

    halfdelay(10);
    running = true;

    while (running)
    {
        int key = getch();
        switch (key)
        {
            case KEY_RESIZE:
                // Resize function
                break;
            case 'q':
                // Exit?
                running = false;
                break;
            default:
                // Default rendering
                break;
        }
    }

    endwin();

    pthread_exit(0);
}