#include <pthread.h>

#include "netex.h"
#include "server.h"

// Sources:
// http://simplestcodings.blogspot.com/2010/08/secure-server-client-using-openssl-in-c.html
// https://stackoverflow.com/questions/40812836/how-to-create-chat-server-using-openssl-in-c
// https://www.cs.cmu.edu/~srini/15-441/F02/Projects/lab01/reference/part1.pdf

int shutdown(int code);

int main(int argc, char *argv[])
{
    netex_init();

    const unsigned long ui_thread = start_ui();
    if (ui_thread != 0)
    {
        PRINT_LINE("Failed to start ui thread!");
        return shutdown(-1);
    }

    // Start server thread
    
    const int init_result = initialize_server(argc, argv);
    if (init_result)
    {
        WARN("Failed to initialize server. Exiting...");
    }
    const int srv_start_result = server_start(); // Is now holding

    if (!srv_start_result)
    {
        WARN("Error running server...");
    }

    // Join server thread

    int ui_thread_result;
    const int join_ui = pthread_join(ui_thread, (void**)&ui_thread_result);
    if (join_ui != 0)
    {
        // Something went wrong
        WARN("Error exiting ui thread! Code: %i", ui_thread_result);
    }

    return shutdown(0);
}

int shutdown(int code)
{
    netex_shutdown();
    return code;
}